#include <qobject.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qtimer.h>

#include <kapplication.h>
#include <kmessagebox.h>
#include <ksystemtray.h>
#include <kpopupmenu.h>
#include <kpassivepopup.h>
#include <knotifyclient.h>
#include <klocale.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/un.h>
#include <unistd.h>
#include <cerrno>
#include <fcntl.h>
#include <pthread.h>
#include <ctime>
#include <cstdio>
#include <cassert>
#include "updater.h"

#define ICON "/usr/share/icons/hicolor/24x24/apps/aurox.png"

time_t Client::yumT= 60 * 1000;

void TH_checkUpdates::run()
{
	int stat=system("yum check-update > /dev/null </dev/null");
	if(WEXITSTATUS( stat )==100)blNewUpdates=true;
	else blNewUpdates=false;
	emit newUpdates(blNewUpdates);
}

void * th_checkUpdates(void* bl)
{
	FILE *out=0,*input=0;
	char c;
	out=fopen("/home/czarek/updater","a+");
	assert(out);
	time_t start=time(NULL);
	input=popen("nice -n 10 yum -d 0 -e 0 check-update  </dev/null","r");
	assert(input);
	while((c=fgetc(input))!=EOF)putc(c,out);
	int stat=pclose(input);
// 	int stat=system("nice -n 10 yum check-update > /dev/null </dev/null");
	if(WEXITSTATUS( stat )==100){ *(bool*)bl=true; }
	else {*(bool*)bl=false;}
	Client::setYumWT(time(NULL)-start);
	fclose(out);
	return 0;
}


void * th_Updater(void*)
{
	static bool UpdaterRn=false;
	if(!UpdaterRn)
	{
		UpdaterRn=true;	
		system("kdesu /usr/bin/pup </dev/null >/dev/null");
		UpdaterRn=false;
	}
	return 0;
}

void Client::setYumWT(time_t T)
{
	Client::yumT=T;
}

Client::Client( )
{
	pyum = new QProcess( this );
	pyum->addArgument("nice");
	pyum->addArgument("-n");
	pyum->addArgument("10");
	pyum->addArgument("yum");
	pyum->addArgument("-d");
	pyum->addArgument("0");
	pyum->addArgument("-e");
	pyum->addArgument("0");
	pyum->addArgument("check-update");
	connect(pyum,SIGNAL(processExited()),this,SLOT(processYumExit()));

	ppup = new QProcess( this );
	ppup->addArgument("kdesu");
	ppup->addArgument("/usr/bin/pup");
	connect(ppup,SIGNAL(processExited()),this,SLOT(checkUpdates()));

	icon= QPixmap( ICON );
	name=QString(tr("Aurox Updater"));
	notify=new KPassivePopup(KPassivePopup::Boxed,this,"Passive Popup About New Updates");
	notify->setView(name,QString(tr("There are new updates available for your system")),icon);
	this->setPixmap(icon);
	this->setCaption( name );
	this->contextMenu( )->changeTitle( -2, name );

	timer = new QTimer;
	QObject::connect( timer, SIGNAL( timeout( ) ), this, SLOT( checkUpdates() ) );
	QObject::connect( this->contextMenu( ), SIGNAL( activated( int ) ), this, SLOT( choice( int ) ) );
	QObject::connect( this, SIGNAL( quitSelected( ) ), this, SLOT( quit( ) ) );
	
	setUpTray( );

	timer->start(45 * 60 * 1000 );
	QTimer::singleShot(2* 60 *1000,this,SLOT(checkUpdates()));
	qDebug("Konstruktor zakonczony");
}

Client::~Client( )
{

}

void Client::choice( int id ) 
{
	switch( id )
	{
		case 1:
			runUpdater();
			break;
	}
}

void Client::setUpTray( )
{

	if( ! this->contextMenu( )->isItemActive( 1 ) && ! this->contextMenu( )->isItemActive( 2 ) )
	{
		this->contextMenu( )->insertItem( tr( "Update" ), 1 );
	}
	this->hide( );
 	this->show();
}

void Client::quit( )
{
	kapp->quit( );
}

void Client::checkUpdates( )
{
 	qDebug("Startuje");
	pyum->start();
	pyum->closeStdin();
}

void Client::updateStatus(bool newUpdates)
{
	static bool lastState=!newUpdates;
	if(newUpdates!=lastState)
	{
		if(newUpdates)
		{
			this->show();
			notify->show();
			KNotifyClient::event(KNotifyClient::notification,"New Updates");
		}
		else this->hide();
		lastState=newUpdates;
	}
}

void Client::runUpdater( )
{
	if(!ppup->isRunning())ppup->start();
}

void Client::processYumExit( )
{
	bool ret=false;
	if(pyum->exitStatus()==100)ret=true;
	emit updateStatus(ret);
}
